<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/**<a name="line.1"></a>
<span class="sourceLineNo">002</span> *<a name="line.2"></a>
<span class="sourceLineNo">003</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.3"></a>
<span class="sourceLineNo">004</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.4"></a>
<span class="sourceLineNo">005</span> * this work for additional information regarding copyright ownership.<a name="line.5"></a>
<span class="sourceLineNo">006</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.6"></a>
<span class="sourceLineNo">007</span> * (the "License"); you may not use this file except in compliance with<a name="line.7"></a>
<span class="sourceLineNo">008</span> * the License.  You may obtain a copy of the License at<a name="line.8"></a>
<span class="sourceLineNo">009</span> *<a name="line.9"></a>
<span class="sourceLineNo">010</span> *     http://www.apache.org/licenses/LICENSE-2.0<a name="line.10"></a>
<span class="sourceLineNo">011</span> *<a name="line.11"></a>
<span class="sourceLineNo">012</span> *  Unless required by applicable law or agreed to in writing, software<a name="line.12"></a>
<span class="sourceLineNo">013</span> *  distributed under the License is distributed on an "AS IS" BASIS,<a name="line.13"></a>
<span class="sourceLineNo">014</span> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.14"></a>
<span class="sourceLineNo">015</span> *  See the License for the specific language governing permissions and<a name="line.15"></a>
<span class="sourceLineNo">016</span> *  limitations under the License.<a name="line.16"></a>
<span class="sourceLineNo">017</span> */<a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2.managed;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import org.apache.commons.dbcp2.BasicDataSource;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import org.apache.commons.dbcp2.ConnectionFactory;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import org.apache.commons.dbcp2.PoolableConnection;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import org.apache.commons.dbcp2.PoolableConnectionFactory;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import org.apache.commons.dbcp2.PoolingDataSource;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import org.apache.commons.dbcp2.Utils;<a name="line.25"></a>
<span class="sourceLineNo">026</span><a name="line.26"></a>
<span class="sourceLineNo">027</span>import javax.sql.DataSource;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import javax.sql.XADataSource;<a name="line.28"></a>
<span class="sourceLineNo">029</span>import javax.transaction.TransactionManager;<a name="line.29"></a>
<span class="sourceLineNo">030</span>import javax.transaction.TransactionSynchronizationRegistry;<a name="line.30"></a>
<span class="sourceLineNo">031</span><a name="line.31"></a>
<span class="sourceLineNo">032</span>import java.sql.SQLException;<a name="line.32"></a>
<span class="sourceLineNo">033</span><a name="line.33"></a>
<span class="sourceLineNo">034</span>/**<a name="line.34"></a>
<span class="sourceLineNo">035</span> * &lt;p&gt;<a name="line.35"></a>
<span class="sourceLineNo">036</span> * BasicManagedDataSource is an extension of BasicDataSource which creates ManagedConnections. This data source can<a name="line.36"></a>
<span class="sourceLineNo">037</span> * create either full two-phase-commit XA connections or one-phase-commit local connections. Both types of connections<a name="line.37"></a>
<span class="sourceLineNo">038</span> * are committed or rolled back as part of the global transaction (a.k.a. XA transaction or JTA Transaction), but only<a name="line.38"></a>
<span class="sourceLineNo">039</span> * XA connections can be recovered in the case of a system crash.<a name="line.39"></a>
<span class="sourceLineNo">040</span> * &lt;/p&gt;<a name="line.40"></a>
<span class="sourceLineNo">041</span> * &lt;p&gt;<a name="line.41"></a>
<span class="sourceLineNo">042</span> * BasicManagedDataSource adds the TransactionManager and XADataSource properties. The TransactionManager property is<a name="line.42"></a>
<span class="sourceLineNo">043</span> * required and is used to enlist connections in global transactions. The XADataSource is optional and if set is the<a name="line.43"></a>
<span class="sourceLineNo">044</span> * class name of the XADataSource class for a two-phase-commit JDBC driver. If the XADataSource property is set, the<a name="line.44"></a>
<span class="sourceLineNo">045</span> * driverClassName is ignored and a DataSourceXAConnectionFactory is created. Otherwise, a standard<a name="line.45"></a>
<span class="sourceLineNo">046</span> * DriverConnectionFactory is created and wrapped with a LocalXAConnectionFactory.<a name="line.46"></a>
<span class="sourceLineNo">047</span> * &lt;/p&gt;<a name="line.47"></a>
<span class="sourceLineNo">048</span> *<a name="line.48"></a>
<span class="sourceLineNo">049</span> * @see BasicDataSource<a name="line.49"></a>
<span class="sourceLineNo">050</span> * @see ManagedConnection<a name="line.50"></a>
<span class="sourceLineNo">051</span> * @since 2.0<a name="line.51"></a>
<span class="sourceLineNo">052</span> */<a name="line.52"></a>
<span class="sourceLineNo">053</span>public class BasicManagedDataSource extends BasicDataSource {<a name="line.53"></a>
<span class="sourceLineNo">054</span><a name="line.54"></a>
<span class="sourceLineNo">055</span>    /** Transaction Registry */<a name="line.55"></a>
<span class="sourceLineNo">056</span>    private TransactionRegistry transactionRegistry;<a name="line.56"></a>
<span class="sourceLineNo">057</span><a name="line.57"></a>
<span class="sourceLineNo">058</span>    /** Transaction Manager */<a name="line.58"></a>
<span class="sourceLineNo">059</span>    private transient TransactionManager transactionManager;<a name="line.59"></a>
<span class="sourceLineNo">060</span><a name="line.60"></a>
<span class="sourceLineNo">061</span>    /** XA data source class name */<a name="line.61"></a>
<span class="sourceLineNo">062</span>    private String xaDataSource;<a name="line.62"></a>
<span class="sourceLineNo">063</span><a name="line.63"></a>
<span class="sourceLineNo">064</span>    /** XA data source instance */<a name="line.64"></a>
<span class="sourceLineNo">065</span>    private XADataSource xaDataSourceInstance;<a name="line.65"></a>
<span class="sourceLineNo">066</span><a name="line.66"></a>
<span class="sourceLineNo">067</span>    /** Transaction Synchronization Registry */<a name="line.67"></a>
<span class="sourceLineNo">068</span>    private transient TransactionSynchronizationRegistry transactionSynchronizationRegistry;<a name="line.68"></a>
<span class="sourceLineNo">069</span><a name="line.69"></a>
<span class="sourceLineNo">070</span>    /**<a name="line.70"></a>
<span class="sourceLineNo">071</span>     * Gets the XADataSource instance used by the XAConnectionFactory.<a name="line.71"></a>
<span class="sourceLineNo">072</span>     *<a name="line.72"></a>
<span class="sourceLineNo">073</span>     * @return the XADataSource<a name="line.73"></a>
<span class="sourceLineNo">074</span>     */<a name="line.74"></a>
<span class="sourceLineNo">075</span>    public synchronized XADataSource getXaDataSourceInstance() {<a name="line.75"></a>
<span class="sourceLineNo">076</span>        return xaDataSourceInstance;<a name="line.76"></a>
<span class="sourceLineNo">077</span>    }<a name="line.77"></a>
<span class="sourceLineNo">078</span><a name="line.78"></a>
<span class="sourceLineNo">079</span>    /**<a name="line.79"></a>
<span class="sourceLineNo">080</span>     * &lt;p&gt;<a name="line.80"></a>
<span class="sourceLineNo">081</span>     * Sets the XADataSource instance used by the XAConnectionFactory.<a name="line.81"></a>
<span class="sourceLineNo">082</span>     * &lt;/p&gt;<a name="line.82"></a>
<span class="sourceLineNo">083</span>     * &lt;p&gt;<a name="line.83"></a>
<span class="sourceLineNo">084</span>     * Note: this method currently has no effect once the pool has been initialized. The pool is initialized the first<a name="line.84"></a>
<span class="sourceLineNo">085</span>     * time one of the following methods is invoked: &lt;code&gt;getConnection, setLogwriter,<a name="line.85"></a>
<span class="sourceLineNo">086</span>     * setLoginTimeout, getLoginTimeout, getLogWriter.&lt;/code&gt;<a name="line.86"></a>
<span class="sourceLineNo">087</span>     * &lt;/p&gt;<a name="line.87"></a>
<span class="sourceLineNo">088</span>     *<a name="line.88"></a>
<span class="sourceLineNo">089</span>     * @param xaDataSourceInstance<a name="line.89"></a>
<span class="sourceLineNo">090</span>     *            XADataSource instance<a name="line.90"></a>
<span class="sourceLineNo">091</span>     */<a name="line.91"></a>
<span class="sourceLineNo">092</span>    public synchronized void setXaDataSourceInstance(final XADataSource xaDataSourceInstance) {<a name="line.92"></a>
<span class="sourceLineNo">093</span>        this.xaDataSourceInstance = xaDataSourceInstance;<a name="line.93"></a>
<span class="sourceLineNo">094</span>        xaDataSource = xaDataSourceInstance == null ? null : xaDataSourceInstance.getClass().getName();<a name="line.94"></a>
<span class="sourceLineNo">095</span>    }<a name="line.95"></a>
<span class="sourceLineNo">096</span><a name="line.96"></a>
<span class="sourceLineNo">097</span>    /**<a name="line.97"></a>
<span class="sourceLineNo">098</span>     * Gets the required transaction manager property.<a name="line.98"></a>
<span class="sourceLineNo">099</span>     *<a name="line.99"></a>
<span class="sourceLineNo">100</span>     * @return the transaction manager used to enlist connections<a name="line.100"></a>
<span class="sourceLineNo">101</span>     */<a name="line.101"></a>
<span class="sourceLineNo">102</span>    public TransactionManager getTransactionManager() {<a name="line.102"></a>
<span class="sourceLineNo">103</span>        return transactionManager;<a name="line.103"></a>
<span class="sourceLineNo">104</span>    }<a name="line.104"></a>
<span class="sourceLineNo">105</span><a name="line.105"></a>
<span class="sourceLineNo">106</span>    /**<a name="line.106"></a>
<span class="sourceLineNo">107</span>     * Gets the optional TransactionSynchronizationRegistry.<a name="line.107"></a>
<span class="sourceLineNo">108</span>     *<a name="line.108"></a>
<span class="sourceLineNo">109</span>     * @return the TSR that can be used to register synchronizations.<a name="line.109"></a>
<span class="sourceLineNo">110</span>     * @since 2.6.0<a name="line.110"></a>
<span class="sourceLineNo">111</span>     */<a name="line.111"></a>
<span class="sourceLineNo">112</span>    public TransactionSynchronizationRegistry getTransactionSynchronizationRegistry() {<a name="line.112"></a>
<span class="sourceLineNo">113</span>        return transactionSynchronizationRegistry;<a name="line.113"></a>
<span class="sourceLineNo">114</span>    }<a name="line.114"></a>
<span class="sourceLineNo">115</span><a name="line.115"></a>
<span class="sourceLineNo">116</span>    /**<a name="line.116"></a>
<span class="sourceLineNo">117</span>     * Gets the transaction registry.<a name="line.117"></a>
<span class="sourceLineNo">118</span>     *<a name="line.118"></a>
<span class="sourceLineNo">119</span>     * @return the transaction registry associating XAResources with managed connections<a name="line.119"></a>
<span class="sourceLineNo">120</span>     */<a name="line.120"></a>
<span class="sourceLineNo">121</span>    protected synchronized TransactionRegistry getTransactionRegistry() {<a name="line.121"></a>
<span class="sourceLineNo">122</span>        return transactionRegistry;<a name="line.122"></a>
<span class="sourceLineNo">123</span>    }<a name="line.123"></a>
<span class="sourceLineNo">124</span><a name="line.124"></a>
<span class="sourceLineNo">125</span>    /**<a name="line.125"></a>
<span class="sourceLineNo">126</span>     * Sets the required transaction manager property.<a name="line.126"></a>
<span class="sourceLineNo">127</span>     *<a name="line.127"></a>
<span class="sourceLineNo">128</span>     * @param transactionManager<a name="line.128"></a>
<span class="sourceLineNo">129</span>     *            the transaction manager used to enlist connections<a name="line.129"></a>
<span class="sourceLineNo">130</span>     */<a name="line.130"></a>
<span class="sourceLineNo">131</span>    public void setTransactionManager(final TransactionManager transactionManager) {<a name="line.131"></a>
<span class="sourceLineNo">132</span>        this.transactionManager = transactionManager;<a name="line.132"></a>
<span class="sourceLineNo">133</span>    }<a name="line.133"></a>
<span class="sourceLineNo">134</span><a name="line.134"></a>
<span class="sourceLineNo">135</span>    /**<a name="line.135"></a>
<span class="sourceLineNo">136</span>     * Sets the optional TransactionSynchronizationRegistry property.<a name="line.136"></a>
<span class="sourceLineNo">137</span>     *<a name="line.137"></a>
<span class="sourceLineNo">138</span>     * @param transactionSynchronizationRegistry<a name="line.138"></a>
<span class="sourceLineNo">139</span>     *            the TSR used to register synchronizations<a name="line.139"></a>
<span class="sourceLineNo">140</span>     * @since 2.6.0<a name="line.140"></a>
<span class="sourceLineNo">141</span>     */<a name="line.141"></a>
<span class="sourceLineNo">142</span>    public void setTransactionSynchronizationRegistry(<a name="line.142"></a>
<span class="sourceLineNo">143</span>            final TransactionSynchronizationRegistry transactionSynchronizationRegistry) {<a name="line.143"></a>
<span class="sourceLineNo">144</span>        this.transactionSynchronizationRegistry = transactionSynchronizationRegistry;<a name="line.144"></a>
<span class="sourceLineNo">145</span>    }<a name="line.145"></a>
<span class="sourceLineNo">146</span><a name="line.146"></a>
<span class="sourceLineNo">147</span>    /**<a name="line.147"></a>
<span class="sourceLineNo">148</span>     * Gets the optional XADataSource class name.<a name="line.148"></a>
<span class="sourceLineNo">149</span>     *<a name="line.149"></a>
<span class="sourceLineNo">150</span>     * @return the optional XADataSource class name<a name="line.150"></a>
<span class="sourceLineNo">151</span>     */<a name="line.151"></a>
<span class="sourceLineNo">152</span>    public synchronized String getXADataSource() {<a name="line.152"></a>
<span class="sourceLineNo">153</span>        return xaDataSource;<a name="line.153"></a>
<span class="sourceLineNo">154</span>    }<a name="line.154"></a>
<span class="sourceLineNo">155</span><a name="line.155"></a>
<span class="sourceLineNo">156</span>    /**<a name="line.156"></a>
<span class="sourceLineNo">157</span>     * Sets the optional XADataSource class name.<a name="line.157"></a>
<span class="sourceLineNo">158</span>     *<a name="line.158"></a>
<span class="sourceLineNo">159</span>     * @param xaDataSource<a name="line.159"></a>
<span class="sourceLineNo">160</span>     *            the optional XADataSource class name<a name="line.160"></a>
<span class="sourceLineNo">161</span>     */<a name="line.161"></a>
<span class="sourceLineNo">162</span>    public synchronized void setXADataSource(final String xaDataSource) {<a name="line.162"></a>
<span class="sourceLineNo">163</span>        this.xaDataSource = xaDataSource;<a name="line.163"></a>
<span class="sourceLineNo">164</span>    }<a name="line.164"></a>
<span class="sourceLineNo">165</span><a name="line.165"></a>
<span class="sourceLineNo">166</span>    @Override<a name="line.166"></a>
<span class="sourceLineNo">167</span>    protected ConnectionFactory createConnectionFactory() throws SQLException {<a name="line.167"></a>
<span class="sourceLineNo">168</span>        if (transactionManager == null) {<a name="line.168"></a>
<span class="sourceLineNo">169</span>            throw new SQLException("Transaction manager must be set before a connection can be created");<a name="line.169"></a>
<span class="sourceLineNo">170</span>        }<a name="line.170"></a>
<span class="sourceLineNo">171</span><a name="line.171"></a>
<span class="sourceLineNo">172</span>        // If xa data source is not specified a DriverConnectionFactory is created and wrapped with a<a name="line.172"></a>
<span class="sourceLineNo">173</span>        // LocalXAConnectionFactory<a name="line.173"></a>
<span class="sourceLineNo">174</span>        if (xaDataSource == null) {<a name="line.174"></a>
<span class="sourceLineNo">175</span>            final ConnectionFactory connectionFactory = super.createConnectionFactory();<a name="line.175"></a>
<span class="sourceLineNo">176</span>            final XAConnectionFactory xaConnectionFactory = new LocalXAConnectionFactory(getTransactionManager(),<a name="line.176"></a>
<span class="sourceLineNo">177</span>                    getTransactionSynchronizationRegistry(), connectionFactory);<a name="line.177"></a>
<span class="sourceLineNo">178</span>            transactionRegistry = xaConnectionFactory.getTransactionRegistry();<a name="line.178"></a>
<span class="sourceLineNo">179</span>            return xaConnectionFactory;<a name="line.179"></a>
<span class="sourceLineNo">180</span>        }<a name="line.180"></a>
<span class="sourceLineNo">181</span><a name="line.181"></a>
<span class="sourceLineNo">182</span>        // Create the XADataSource instance using the configured class name if it has not been set<a name="line.182"></a>
<span class="sourceLineNo">183</span>        if (xaDataSourceInstance == null) {<a name="line.183"></a>
<span class="sourceLineNo">184</span>            Class&lt;?&gt; xaDataSourceClass = null;<a name="line.184"></a>
<span class="sourceLineNo">185</span>            try {<a name="line.185"></a>
<span class="sourceLineNo">186</span>                xaDataSourceClass = Class.forName(xaDataSource);<a name="line.186"></a>
<span class="sourceLineNo">187</span>            } catch (final Exception t) {<a name="line.187"></a>
<span class="sourceLineNo">188</span>                final String message = "Cannot load XA data source class '" + xaDataSource + "'";<a name="line.188"></a>
<span class="sourceLineNo">189</span>                throw new SQLException(message, t);<a name="line.189"></a>
<span class="sourceLineNo">190</span>            }<a name="line.190"></a>
<span class="sourceLineNo">191</span><a name="line.191"></a>
<span class="sourceLineNo">192</span>            try {<a name="line.192"></a>
<span class="sourceLineNo">193</span>                xaDataSourceInstance = (XADataSource) xaDataSourceClass.getConstructor().newInstance();<a name="line.193"></a>
<span class="sourceLineNo">194</span>            } catch (final Exception t) {<a name="line.194"></a>
<span class="sourceLineNo">195</span>                final String message = "Cannot create XA data source of class '" + xaDataSource + "'";<a name="line.195"></a>
<span class="sourceLineNo">196</span>                throw new SQLException(message, t);<a name="line.196"></a>
<span class="sourceLineNo">197</span>            }<a name="line.197"></a>
<span class="sourceLineNo">198</span>        }<a name="line.198"></a>
<span class="sourceLineNo">199</span><a name="line.199"></a>
<span class="sourceLineNo">200</span>        // finally, create the XAConnectionFactory using the XA data source<a name="line.200"></a>
<span class="sourceLineNo">201</span>        final XAConnectionFactory xaConnectionFactory = new DataSourceXAConnectionFactory(getTransactionManager(),<a name="line.201"></a>
<span class="sourceLineNo">202</span>                xaDataSourceInstance, getUsername(), Utils.toCharArray(getPassword()), getTransactionSynchronizationRegistry());<a name="line.202"></a>
<span class="sourceLineNo">203</span>        transactionRegistry = xaConnectionFactory.getTransactionRegistry();<a name="line.203"></a>
<span class="sourceLineNo">204</span>        return xaConnectionFactory;<a name="line.204"></a>
<span class="sourceLineNo">205</span>    }<a name="line.205"></a>
<span class="sourceLineNo">206</span><a name="line.206"></a>
<span class="sourceLineNo">207</span>    @Override<a name="line.207"></a>
<span class="sourceLineNo">208</span>    protected DataSource createDataSourceInstance() throws SQLException {<a name="line.208"></a>
<span class="sourceLineNo">209</span>        final PoolingDataSource&lt;PoolableConnection&gt; pds = new ManagedDataSource&lt;&gt;(getConnectionPool(),<a name="line.209"></a>
<span class="sourceLineNo">210</span>                transactionRegistry);<a name="line.210"></a>
<span class="sourceLineNo">211</span>        pds.setAccessToUnderlyingConnectionAllowed(isAccessToUnderlyingConnectionAllowed());<a name="line.211"></a>
<span class="sourceLineNo">212</span>        return pds;<a name="line.212"></a>
<span class="sourceLineNo">213</span>    }<a name="line.213"></a>
<span class="sourceLineNo">214</span><a name="line.214"></a>
<span class="sourceLineNo">215</span>    /**<a name="line.215"></a>
<span class="sourceLineNo">216</span>     * Creates the PoolableConnectionFactory and attaches it to the connection pool.<a name="line.216"></a>
<span class="sourceLineNo">217</span>     *<a name="line.217"></a>
<span class="sourceLineNo">218</span>     * @param driverConnectionFactory<a name="line.218"></a>
<span class="sourceLineNo">219</span>     *            JDBC connection factory created by {@link #createConnectionFactory()}<a name="line.219"></a>
<span class="sourceLineNo">220</span>     * @throws SQLException<a name="line.220"></a>
<span class="sourceLineNo">221</span>     *             if an error occurs creating the PoolableConnectionFactory<a name="line.221"></a>
<span class="sourceLineNo">222</span>     */<a name="line.222"></a>
<span class="sourceLineNo">223</span>    @Override<a name="line.223"></a>
<span class="sourceLineNo">224</span>    protected PoolableConnectionFactory createPoolableConnectionFactory(final ConnectionFactory driverConnectionFactory)<a name="line.224"></a>
<span class="sourceLineNo">225</span>            throws SQLException {<a name="line.225"></a>
<span class="sourceLineNo">226</span>        PoolableConnectionFactory connectionFactory = null;<a name="line.226"></a>
<span class="sourceLineNo">227</span>        try {<a name="line.227"></a>
<span class="sourceLineNo">228</span>            connectionFactory = new PoolableManagedConnectionFactory((XAConnectionFactory) driverConnectionFactory,<a name="line.228"></a>
<span class="sourceLineNo">229</span>                    getRegisteredJmxName());<a name="line.229"></a>
<span class="sourceLineNo">230</span>            connectionFactory.setValidationQuery(getValidationQuery());<a name="line.230"></a>
<span class="sourceLineNo">231</span>            connectionFactory.setValidationQueryTimeout(getValidationQueryTimeout());<a name="line.231"></a>
<span class="sourceLineNo">232</span>            connectionFactory.setConnectionInitSql(getConnectionInitSqls());<a name="line.232"></a>
<span class="sourceLineNo">233</span>            connectionFactory.setDefaultReadOnly(getDefaultReadOnly());<a name="line.233"></a>
<span class="sourceLineNo">234</span>            connectionFactory.setDefaultAutoCommit(getDefaultAutoCommit());<a name="line.234"></a>
<span class="sourceLineNo">235</span>            connectionFactory.setDefaultTransactionIsolation(getDefaultTransactionIsolation());<a name="line.235"></a>
<span class="sourceLineNo">236</span>            connectionFactory.setDefaultCatalog(getDefaultCatalog());<a name="line.236"></a>
<span class="sourceLineNo">237</span>            connectionFactory.setDefaultSchema(getDefaultSchema());<a name="line.237"></a>
<span class="sourceLineNo">238</span>            connectionFactory.setCacheState(getCacheState());<a name="line.238"></a>
<span class="sourceLineNo">239</span>            connectionFactory.setPoolStatements(isPoolPreparedStatements());<a name="line.239"></a>
<span class="sourceLineNo">240</span>            connectionFactory.setClearStatementPoolOnReturn(isClearStatementPoolOnReturn());<a name="line.240"></a>
<span class="sourceLineNo">241</span>            connectionFactory.setMaxOpenPreparedStatements(getMaxOpenPreparedStatements());<a name="line.241"></a>
<span class="sourceLineNo">242</span>            connectionFactory.setMaxConnLifetimeMillis(getMaxConnLifetimeMillis());<a name="line.242"></a>
<span class="sourceLineNo">243</span>            connectionFactory.setRollbackOnReturn(getRollbackOnReturn());<a name="line.243"></a>
<span class="sourceLineNo">244</span>            connectionFactory.setAutoCommitOnReturn(getAutoCommitOnReturn());<a name="line.244"></a>
<span class="sourceLineNo">245</span>            connectionFactory.setDefaultQueryTimeout(getDefaultQueryTimeout());<a name="line.245"></a>
<span class="sourceLineNo">246</span>            connectionFactory.setFastFailValidation(getFastFailValidation());<a name="line.246"></a>
<span class="sourceLineNo">247</span>            connectionFactory.setDisconnectionSqlCodes(getDisconnectionSqlCodes());<a name="line.247"></a>
<span class="sourceLineNo">248</span>            validateConnectionFactory(connectionFactory);<a name="line.248"></a>
<span class="sourceLineNo">249</span>        } catch (final RuntimeException e) {<a name="line.249"></a>
<span class="sourceLineNo">250</span>            throw e;<a name="line.250"></a>
<span class="sourceLineNo">251</span>        } catch (final Exception e) {<a name="line.251"></a>
<span class="sourceLineNo">252</span>            throw new SQLException("Cannot create PoolableConnectionFactory (" + e.getMessage() + ")", e);<a name="line.252"></a>
<span class="sourceLineNo">253</span>        }<a name="line.253"></a>
<span class="sourceLineNo">254</span>        return connectionFactory;<a name="line.254"></a>
<span class="sourceLineNo">255</span>    }<a name="line.255"></a>
<span class="sourceLineNo">256</span>}<a name="line.256"></a>




























































</pre>
</div>
</body>
</html>
